!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2002.05.18 ORStyleItalics [GLULX]
! A simple implementation of the ORStyleHint class which sets up the emphasised 
! style to show as italics.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! Turns the emphasised style in a GLULX game to italics. 
!--------------------------------------------------------------------------------------
! AutoDep:	ORStyleHint
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#ifdef USE_ORStyleItalics; #include "ORStyleItalics"; #endif;
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORStyleItalics; 
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2002.04.19	Initial Creation
! 2002.05.01	Modified comments.
! 2002.05.18	Renamed from ORGlulxItalics to fit existing naming convention.
!--------------------------------------------------------------------------------------
#ifdef USE_ORStyleItalics;
	#ifndef TARGET_GLULX;
		message "          Processing library extension ORStyleItalics...(ignoring GLULX specific)";
	#ifnot;
		message "          Processing library extension ORStyleItalics...";
	#endif;
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------
	#ifndef USE_ORStyleHint; Constant USE_ORStyleHint; message "          ****Forcing inclusion of ORStyleHint****"; #include "ORStyleHint"; #endif; 
!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORStyleItalics_DONEREPLACE; constant ORStyleItalics_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORStyleItalics_DONEMESSAGE; constant ORStyleItalics_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORStyleItalics requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORStyleItalics_DONECODE;constant ORStyleItalics_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------
	#ifdef TARGET_GLULX;
		ORStyleHint	!--make the emphasized style appear as non-bold italics
			with user_num style_Emphasized
			,	windows wintype_TextBuffer
			,	hints stylehint_Weight stylehint_Oblique
			,	values 0 1
		;
	#endif;
!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORStyleItalics_DONEGRAMMAR; constant ORStyleItalics_DONEGRAMMAR; #ifdef ORStyleItalics_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #endif;
