!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2003.02.21 ORWriteAfterEntry
! A rearangement of the WriteAfterEntry routine.  No actual code has been altered (at
! least not in any significant way) but the routine has been broken into smaller 
! componants which can be overriden by other modules.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep:	none
!--------------------------------------------------------------------------------------
! ORLibDev: Note, that this module is not useful as a library extension alone.  By 
!     itself it provides no new functionality for the IF developer. Instead it provides
!     a basis for other modules to be built upon and will primarily be useful to those 
!     who are developing ORLibrary entries of their own.
!--------------------------------------------------------------------------------------
! Although arranged differently, this code is nevertheless the same WriteAfterEntry
! routine that comes from Graham Nelson's standard library (actually Andrew Plotkin's
! Biplatform library which is a modified version of Graham Nelson's standard library).  
! In any case, it falls under the same copyright as the code upon which it was based 
! which can be found in the standard library's verblibm file.  The header to this file 
! is included now:
!--------------------------------------------------------------------------------------
	!  VERBLIBM:  Core of standard verbs library.
	!
	!  Supplied for use with Inform 6                         Serial number 991113
	!                                                                 Release 6/10
	!  (c) Graham Nelson 1993, 1994, 1995, 1996, 1997, 1998, 1999
	!      but freely usable (see manuals)
!--------------------------------------------------------------------------------------
! This module replaces the large and bulky original version of WriteAfterEntry with a 
! smaller version that does little more than make calls to routines that are 
! compartmentalized versions of the code originally making up the WriteAfterEntry routine. 
! These smaller routines can more selectively be replaced by other modules.
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#ifdef USE_ORWriteAfterEntry; #include "ORWriteAfterEntry"; #endif;
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORWriteAfterEntry; 
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2002.00.00	Initial Creation
!--------------------------------------------------------------------------------------
#ifdef USE_ORWriteAfterEntry;message "          Processing library extension ORWriteAfterEntry...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORWriteAfterEntry_DONEREPLACE; constant ORWriteAfterEntry_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------
	replace WriteAfterEntry;
	global _WAE_flag=0;
	global _WAE_flag2=0;
	global _WAE_flag3=0;
!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORWriteAfterEntry_DONEMESSAGE; constant ORWriteAfterEntry_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORWriteAfterEntry requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORWriteAfterEntry_DONECODE;constant ORWriteAfterEntry_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------
[WriteAfterEntry o depth stack_p flag flag2 flag3;
	flag=_WAE_flag;flag2=_WAE_flag2;flag3=_WAE_flag3; !--this routine is called recursively.  Lets save off the values of the flag variables that we made global.
	_WAE_flag=0;_WAE_flag2=0;_WAE_flag3=0;
		if(WAE_PartInv(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_FullInv(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_Conceal(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_Always(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_Recurse(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_IsOrAre(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_Newline(o,depth,stack_p)==true) jump exit_wae;
		if(WAE_DoList(o,depth,stack_p)==true) jump exit_wae;
.exit_wae;
	_WAE_flag=flag;_WAE_flag2=flag2;_WAE_flag3=flag3;
];

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORWriteAfterEntry_DONEGRAMMAR; constant ORWriteAfterEntry_DONEGRAMMAR; #ifdef ORWriteAfterEntry_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------
system_file;
#ifndef WAE_PartInv;
[ WAE_PartInv o comb depth stack_p;depth=depth; stack_p=stack_p;
	if (c_style & PARTINV_BIT ~= 0) {
		comb=0;
		if (o has light && location hasnt light) comb=comb+1;
		if (o has container && o hasnt open)     comb=comb+2;
		if ((o has container && (o has open || o has transparent))
			&& (child(o)==0)) comb=comb+4;
		if (comb==1) L__M(##ListMiscellany, 1, o);
		if (comb==2) L__M(##ListMiscellany, 2, o);
		if (comb==3) L__M(##ListMiscellany, 3, o);
		if (comb==4) L__M(##ListMiscellany, 4, o);
		if (comb==5) L__M(##ListMiscellany, 5, o);
		if (comb==6) L__M(##ListMiscellany, 6, o);
		if (comb==7) L__M(##ListMiscellany, 7, o);
	}
	rfalse;
];
#endif;
#ifndef WAE_FullInv;
[WAE_FullInv o depth stack_p;depth=depth; stack_p=stack_p;
	if (c_style & FULLINV_BIT ~= 0) {
		if (o.invent ~= 0)
		{   inventory_stage=2;
			if (RunRoutines(o,invent)~=0)
			{   if (c_style & NEWLINE_BIT ~= 0) new_line;
				rtrue;
			}
		}
		if (o has light && o has worn)
		{    L__M(##ListMiscellany, 8); _WAE_flag2=1; }
		else
		{   if (o has light) {  L__M(##ListMiscellany, 9, o); _WAE_flag2=1; }
			if (o has worn)  {  L__M(##ListMiscellany, 10, o); _WAE_flag2=1; }
		}
		if (o has container)
		{   if (o has openable)
			{   if (_WAE_flag2==1) print (string) AND__TX;
				else L__M(##ListMiscellany, 11, o);
				if (o has open)
				{   if (child(o)==0) L__M(##ListMiscellany, 13, o);
					else L__M(##ListMiscellany, 12, o);
				}
				else
				{   if (o has lockable && o has locked)
						L__M(##ListMiscellany, 15, o);
					else L__M(##ListMiscellany, 14, o);
				}
				_WAE_flag2=1;
			}
			else
				if (child(o)==0 && o has transparent)
				{   if (_WAE_flag2==1) L__M(##ListMiscellany, 16, o);
					else L__M(##ListMiscellany, 17, o);
				}
		}
		if (_WAE_flag2==1) print ")";
	}
	rfalse;
];
#endif;
#ifndef WAE_Conceal;
[WAE_Conceal o p depth stack_p; depth=depth; stack_p=stack_p;
	if (c_style & CONCEAL_BIT == 0)
	{   _WAE_flag3 = children(o);
		_WAE_flag2 = child(o);
	}
	else
	{   _WAE_flag3 = 0;
		objectloop (p in o)
			if (p hasnt concealed && p hasnt scenery) { _WAE_flag3++; _WAE_flag2 = p; }
	}
	rfalse;
];
#endif;
#ifndef WAE_Always;
[WAE_Always o depth stack_p; depth=depth; stack_p=stack_p;
  if (c_style & ALWAYS_BIT ~= 0 && _WAE_flag3>0)
  {   if (c_style & ENGLISH_BIT ~= 0) L__M(##ListMiscellany, 18, o);
      _WAE_flag=1;
  }
  rfalse;
];

#endif;
#ifndef WAE_Recurse;
[WAE_Recurse o depth stack_p; depth=depth; stack_p=stack_p;
  if (c_style & RECURSE_BIT ~= 0 && _WAE_flag3>0)
  {   if (o has supporter)
      {   if (c_style & ENGLISH_BIT ~= 0)
          {   if (c_style & TERSE_BIT ~= 0)
                   L__M(##ListMiscellany, 19, o);
              else L__M(##ListMiscellany, 20, o);
              if (o has animate) print (string) WHOM__TX;
              else print (string) WHICH__TX;
          }
          _WAE_flag=1;
      }
      if (o has container && (o has open || o has transparent))
      {   if (c_style & ENGLISH_BIT ~= 0)
          {   if (c_style & TERSE_BIT ~= 0)
                   L__M(##ListMiscellany, 21, o);
              else L__M(##ListMiscellany, 22, o);
              if (o has animate) print (string) WHOM__TX;
              else print (string) WHICH__TX;
          }
          _WAE_flag=1;
      }
  }
  rfalse;
];
#endif;
#ifndef WAE_IsOrAre;
[WAE_IsOrAre o depth stack_p; o=o; depth=depth; stack_p=stack_p;
  if (_WAE_flag==1 && c_style & ENGLISH_BIT ~= 0)
  {   if (_WAE_flag3 > 1 || _WAE_flag2 has pluralname)
           print (string) ARE2__TX;
      else print (string) IS2__TX;
  }
  rfalse;
];
#endif;
#ifndef WAE_Newline;
[WAE_Newline o depth stack_p; o=o; depth=depth; stack_p=stack_p;
	if (c_style & NEWLINE_BIT ~= 0) new_line;	
	rfalse;
];
#endif;
#ifndef WAE_DoList;
[WAE_DoList o depth stack_p; depth=depth; stack_p=stack_p;
  if (_WAE_flag==1)
  {   o = child(o);
#ifndef TARGET_GLULX; !--TARGET_ZCODE;
      @push lt_value; @push listing_together; @push listing_size;
#ifnot; ! TARGET_GLULX;
      @copy lt_value sp; 
      @copy listing_together sp; 
      @copy listing_size sp;
#endif; ! TARGET_;
      lt_value = 0; listing_together = 0; listing_size = 0;
      WriteListR(o, depth+1, stack_p);
#ifndef TARGET_GLULX;!--TARGET_ZCODE;
      @pull listing_size; @pull listing_together; @pull lt_value;
#ifnot; ! TARGET_GLULX;
      @copy sp listing_size; 
      @copy sp listing_together; 
      @copy sp lt_value;
#endif; ! TARGET_;
      if (c_style & TERSE_BIT ~= 0) print ")";
  }
  rfalse;
];
#endif;
!--------------------------------------------------------------------------------------
#endif; #endif; #endif;